diff --git a/src/main/java/net/minecraft/core/item/EmptyBucketItem.java b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
index f0ad17c3c..c587fdef8 100644
--- a/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
+++ b/src/main/java/net/minecraft/core/item/EmptyBucketItem.java
@@ -25,33 +25,18 @@ public class EmptyBucketItem extends Item
     @Override
     public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
-        float f = 1.0F;
-        float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
-        float f2 = entityplayer.yRotO + (entityplayer.yRot - entityplayer.yRotO) * f;
-        double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
-        float yOff = entityplayer instanceof ServerPlayer ? entityplayer.getHeightOffset() : 0;
-        double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo)) + yOff;
-        double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
-        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
-        float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
-        float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
-        float f5 = -MathHelper.cos(-f1 * 0.01745329F);
-        float f6 = MathHelper.sin(-f1 * 0.01745329F);
-        float f7 = f4 * f5;
-        float f8 = f6;
-        float f9 = f3 * f5;
         double reachDistance = entityplayer.getGamemode().getBlockReachDistance();
-        Vec3 vec31 = vec3.add((double)f7 * reachDistance, (double)f8 * reachDistance, (double)f9 * reachDistance);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3, vec31, true);
-        if(movingobjectposition == null)
+        HitResult hitResult = entityplayer.rayTrace(reachDistance, 1f, true, false);
+
+        if(hitResult == null)
         {
             return itemstack;
         }
-        if(movingobjectposition.hitType == HitResult.HitType.TILE)
+        if(hitResult.hitType == HitResult.HitType.TILE)
         {
-            int i = movingobjectposition.x;
-            int j = movingobjectposition.y;
-            int k = movingobjectposition.z;
+            int i = hitResult.x;
+            int j = hitResult.y;
+            int k = hitResult.z;
             if(!world.canMineBlock(entityplayer, i, j, k))
             {
                 return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/FireStrikerItem.java b/src/main/java/net/minecraft/core/item/FireStrikerItem.java
index bfd478a53..9e18c7434 100644
--- a/src/main/java/net/minecraft/core/item/FireStrikerItem.java
+++ b/src/main/java/net/minecraft/core/item/FireStrikerItem.java
@@ -4,13 +4,22 @@ package net.minecraft.core.item;
 //            Item, World, Block, FireBlock,
 //            ItemStack, Player
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BrazierBlock;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.block.TNTBlock;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class FireStrikerItem extends Item
 {
 
@@ -39,4 +48,27 @@ public class FireStrikerItem extends Item
         }
         return false;
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        if (!onUseItemOnBlock(itemStack, null, world, blockX, blockY, blockZ, direction.getSide(), 0.5, 0.5)) {
+            blockX += direction.getOffsetX();
+            blockY += direction.getOffsetY();
+            blockZ += direction.getOffsetZ();
+            Block b = world.getBlock(blockX, blockY, blockZ);
+            if (b instanceof BrazierBlock && !((BrazierBlock)b).isBurning()) {
+                if (world.getBlock(blockX + 1,  blockY, blockZ) instanceof FluidBlock ||
+                    world.getBlock(blockX - 1,  blockY, blockZ) instanceof FluidBlock ||
+                    world.getBlock(blockX,      blockY, blockZ + 1) instanceof FluidBlock ||
+                    world.getBlock(blockX,      blockY, blockZ - 1) instanceof FluidBlock) {
+                    return;
+                }
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.BRAZIER_ACTIVE.id, 0);
+                itemStack.damageItem(1, null);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
+            } else if (b instanceof TNTBlock) {
+                ((TNTBlock)b).ignite(world, blockX, blockY, blockZ, true);
+            }
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/IBonemealable.java b/src/main/java/net/minecraft/core/item/IBonemealable.java
index 936ebb1e8..0fe7a2762 100644
--- a/src/main/java/net/minecraft/core/item/IBonemealable.java
+++ b/src/main/java/net/minecraft/core/item/IBonemealable.java
@@ -3,7 +3,8 @@ package net.minecraft.core.item;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public interface IBonemealable {
-    boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced);
+    boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced);
 }
diff --git a/src/main/java/net/minecraft/core/item/IDispensable.java b/src/main/java/net/minecraft/core/item/IDispensable.java
index da3871c81..b4bffb2bf 100644
--- a/src/main/java/net/minecraft/core/item/IDispensable.java
+++ b/src/main/java/net/minecraft/core/item/IDispensable.java
@@ -5,9 +5,9 @@ import net.minecraft.core.world.World;
 import java.util.Random;
 
 public interface IDispensable {
-    void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random);
+    void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int yOffset, int zOffset, Random random);
 
     default boolean isRemovedOnDispense() {
         return true;
     }
-}
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index e5eca2bcb..4dc0b3dd1 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -5,6 +5,7 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatItem;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
@@ -15,6 +16,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -160,6 +162,9 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return false;
     }
 
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+    }
+
     public float getStrVsBlock(ItemStack itemstack, Block block)
     {
         return 1.0F;
diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/src/main/java/net/minecraft/core/item/ItemStack.java
index 1497bf1fb..8cd3acf39 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -255,7 +255,7 @@ public final class ItemStack {
         return Item.itemsList[itemID].getMaxDamage();
     }
 
-    public void damageItem(int i, Entity entity)
+    public void damageItem(int i, @Nullable Entity entity)
     {
         if (entity instanceof Player) {
             if (!((Player)entity).getGamemode().toolDurability()) return;
@@ -314,10 +314,10 @@ public final class ItemStack {
         }
     }
 
-    public boolean consumeItem(Player entityplayer){
+    public boolean consumeItem(@Nullable Player entityplayer){
         if(stackSize <= 0)
             return false;
-        if (entityplayer.getGamemode().consumeBlocks()) {
+        if (entityplayer == null || entityplayer.getGamemode().consumeBlocks()) {
             stackSize--;
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/item/JarItem.java b/src/main/java/net/minecraft/core/item/JarItem.java
index 6ec22d8b3..9d56fd748 100644
--- a/src/main/java/net/minecraft/core/item/JarItem.java
+++ b/src/main/java/net/minecraft/core/item/JarItem.java
@@ -6,6 +6,8 @@ import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
@@ -19,20 +21,22 @@ public class JarItem extends PlaceableItem {
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-        if (player.isSneaking()) {
+    public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        if (player != null && player.isSneaking()) {
             return super.onUseItemOnBlock(stack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         }
-        int count = stack.stackSize;
-        ItemStack used = onUseItem(stack, world, player);
-        if (used != null && used.stackSize != count){
-            return true;
+        if (player != null) {int count = stack.stackSize;
+            ItemStack used = onUseItem(stack, world, player);
+            if (used != null && used.stackSize != count){
+                return true;
+            }
+
         }
         return super.onUseItemOnBlock(stack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, @NotNull Player entityplayer)
     {
         if (entityplayer.isSneaking()) {
             return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/LabelItem.java b/src/main/java/net/minecraft/core/item/LabelItem.java
index 366a5ee7b..cc7a3400a 100644
--- a/src/main/java/net/minecraft/core/item/LabelItem.java
+++ b/src/main/java/net/minecraft/core/item/LabelItem.java
@@ -1,8 +1,19 @@
 package net.minecraft.core.item;
 
+import com.b100.utils.StringUtils;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.SheepMob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
+import java.util.Iterator;
+import java.util.List;
+import java.util.Random;
+
 public class LabelItem extends Item
 {
     protected LabelItem(String name, String namespaceId, int id) {
@@ -31,4 +42,20 @@ public class LabelItem extends Item
 		}
 		return stack;
 	}
+
+	@Override
+	public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+		if (!itemStack.hasCustomName()) return;
+		blockX += direction.getOffsetX();
+		blockY += direction.getOffsetY();
+		blockZ += direction.getOffsetZ();
+		AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
+		List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(null, box);
+        for (Entity entity : entities) {
+            if (entity instanceof Mob && !entity.hadNicknameSet) {
+                ((Mob) entity).setNickname(StringUtils.substring(itemStack.getCustomName(), 0, 32));
+				break;
+            }
+        }
+	}
 }
diff --git a/src/main/java/net/minecraft/core/item/MinecartItem.java b/src/main/java/net/minecraft/core/item/MinecartItem.java
index 0735d2dd6..136a97ba8 100644
--- a/src/main/java/net/minecraft/core/item/MinecartItem.java
+++ b/src/main/java/net/minecraft/core/item/MinecartItem.java
@@ -4,10 +4,16 @@ package net.minecraft.core.item;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.RailBlock;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 public class MinecartItem extends Item {
     public final int minecartType;
@@ -18,16 +24,24 @@ public class MinecartItem extends Item {
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         Block block = world.getBlock(blockX, blockY, blockZ);
         if (!(block instanceof RailBlock)) { return false; }
 
         if(!world.isClientSide) {
             world.entityJoinedWorld(new MinecartEntity(world, (float) blockX + 0.5F, (float) blockY + 0.5F, (float) blockZ + 0.5F, minecartType));
         }
-        if (entityplayer.getGamemode().consumeBlocks()) {
+        if (player == null || player.getGamemode().consumeBlocks()) {
             itemstack.stackSize--;
         }
         return true;
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        int x = blockX + direction.getOffsetX();
+        int y = blockY + direction.getOffsetY();
+        int z = blockZ + direction.getOffsetZ();
+        onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/MusicDiscItem.java b/src/main/java/net/minecraft/core/item/MusicDiscItem.java
index 3b7f2cff8..16588bba0 100644
--- a/src/main/java/net/minecraft/core/item/MusicDiscItem.java
+++ b/src/main/java/net/minecraft/core/item/MusicDiscItem.java
@@ -5,12 +5,19 @@ package net.minecraft.core.item;
 //            Item, World, Block, JukeboxBlock,
 //            ItemStack, Player
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.JukeboxBlock;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class MusicDiscItem extends Item
 {
     public final String recordName;
@@ -32,7 +39,7 @@ public class MusicDiscItem extends Item
         {
             if (!world.isClientSide) {
                 ((JukeboxBlock) Blocks.JUKEBOX).playRecord(world, blockX, blockY, blockZ, id);
-                world.playSoundEffect(null, 1005, blockX, blockY, blockZ, id);
+                world.playBlockEvent(null, LevelListener.EVENT_JUKEBOX_TOGGLE, blockX, blockY, blockZ, id);
                 itemstack.consumeItem(entityplayer);
             }
             return true;
@@ -41,4 +48,17 @@ public class MusicDiscItem extends Item
             return false;
         }
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        int x = blockX + direction.getOffsetX();
+        int y = blockY + direction.getOffsetY();
+        int z = blockZ + direction.getOffsetZ();
+        int b = world.getBlockId(x, y, z);
+        if (b == Blocks.JUKEBOX.id && world.getBlockMetadata(x, y, z) == 0) {
+            ((JukeboxBlock) Blocks.JUKEBOX).playRecord(world, x, y, z, id);
+            world.playBlockEvent(null, LevelListener.EVENT_JUKEBOX_TOGGLE, blockX, blockY, blockZ, id);
+            itemStack.consumeItem(null);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/PaintBrushItem.java b/src/main/java/net/minecraft/core/item/PaintBrushItem.java
index 13531e0f1..39a3d2b42 100644
--- a/src/main/java/net/minecraft/core/item/PaintBrushItem.java
+++ b/src/main/java/net/minecraft/core/item/PaintBrushItem.java
@@ -3,11 +3,17 @@ package net.minecraft.core.item;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.IPaintable;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 public class PaintBrushItem extends Item {
     private static final int DAMAGE_PER_DYE = 8;
@@ -19,7 +25,7 @@ public class PaintBrushItem extends Item {
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if (itemstack.getMetadata() >= itemstack.getMaxDamage()) {
             return false;
         }
@@ -32,7 +38,7 @@ public class PaintBrushItem extends Item {
             final DyeColor color = getColor(itemstack);
             if (color != null) {
                 paintable.setColor(world, blockX, blockY, blockZ, color);
-                itemstack.damageItem(1, entityplayer);
+                itemstack.damageItem(1, player);
                 return true;
             }
         }
@@ -40,6 +46,14 @@ public class PaintBrushItem extends Item {
         return false;
     }
 
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        int x = blockX + direction.getOffsetX();
+        int y = blockY + direction.getOffsetY();
+        int z = blockZ + direction.getOffsetZ();
+        onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+    }
+
     @Override
     public boolean hasInventoryInteraction() {
         return true;
diff --git a/src/main/java/net/minecraft/core/item/PebbleItem.java b/src/main/java/net/minecraft/core/item/PebbleItem.java
index 8e4a8538b..18758812e 100644
--- a/src/main/java/net/minecraft/core/item/PebbleItem.java
+++ b/src/main/java/net/minecraft/core/item/PebbleItem.java
@@ -1,24 +1,21 @@
 package net.minecraft.core.item;
 
-// Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, World, SnowballProjectile,
-//            Player
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.PebbleProjectile;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class PebbleItem
-    extends Item
-    implements IDispensable
+public class PebbleItem extends Item implements IDispensable
 {
 
     public PebbleItem(String name, String namespaceId, int id)
@@ -42,7 +39,7 @@ public class PebbleItem
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -73,8 +70,8 @@ public class PebbleItem
             if (newMeta < 3)
             {
                 world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                itemstack.consumeItem(entityplayer);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                itemstack.consumeItem(player);
                 return true;
             }
 
@@ -105,8 +102,8 @@ public class PebbleItem
             if (newMeta < 3)
             {
                 world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                itemstack.consumeItem(entityplayer);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                itemstack.consumeItem(player);
                 return true;
             }
 
@@ -117,9 +114,9 @@ public class PebbleItem
         {
             if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, 0))
             {
-                Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
-                itemstack.consumeItem(entityplayer);
+                Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                itemstack.consumeItem(player);
 				return true;
             }
         }
@@ -128,9 +125,17 @@ public class PebbleItem
     }
 
     @Override
-    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        PebbleProjectile pebbleProjectile = new PebbleProjectile(world, blockX + offX, blockY + offY, blockZ + offZ);
+        pebbleProjectile.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        world.entityJoinedWorld(pebbleProjectile);
+        itemStack.stackSize -= 1;
+    }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int yOffset, int zOffset, Random random) {
         PebbleProjectile pebbleProjectile = new PebbleProjectile(world, x, y, z);
-        pebbleProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        pebbleProjectile.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
         world.entityJoinedWorld(pebbleProjectile);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/PlaceableItem.java b/src/main/java/net/minecraft/core/item/PlaceableItem.java
index 9cdf81b84..76f265a6c 100644
--- a/src/main/java/net/minecraft/core/item/PlaceableItem.java
+++ b/src/main/java/net/minecraft/core/item/PlaceableItem.java
@@ -1,10 +1,16 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 public class PlaceableItem extends Item {
 	
@@ -17,7 +23,7 @@ public class PlaceableItem extends Item {
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -32,7 +38,11 @@ public class PlaceableItem extends Item {
 		}
 		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
-				blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+				if (player == null) {
+					blockToPlace.onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+				} else {
+					blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
@@ -40,4 +50,14 @@ public class PlaceableItem extends Item {
 		return false;
 	}
 
+	@Override
+	public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+		int x = blockX + direction.getOffsetX();
+		int y = blockY + direction.getOffsetY();
+		int z = blockZ + direction.getOffsetZ();
+		Block b = world.getBlock(x, y, z);
+		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+			onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+		}
+	}
 }
diff --git a/src/main/java/net/minecraft/core/item/RopeItem.java b/src/main/java/net/minecraft/core/item/RopeItem.java
index 955f815e1..52366e44b 100644
--- a/src/main/java/net/minecraft/core/item/RopeItem.java
+++ b/src/main/java/net/minecraft/core/item/RopeItem.java
@@ -1,22 +1,27 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 public class RopeItem extends PlaceableItem {
     public RopeItem(String name, String namespaceId, int id, Block blockToPlace) {
         super(name, namespaceId, id, blockToPlace);
     }
     @Override
-    public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(stack.stackSize <= 0) {
             return false;
         }
         boolean placeOnSide = true;
-        if (world.getBlock(blockX, blockY, blockZ) == blockToPlace && !player.isSneaking()){
+        if (world.getBlock(blockX, blockY, blockZ) == blockToPlace && player != null && !player.isSneaking()){
             placeOnSide = false;
             int _y = blockY;
             while (_y > 0){
@@ -43,11 +48,16 @@ public class RopeItem extends PlaceableItem {
         }
         if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
-                blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                if (player == null) {
+                    blockToPlace.onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+                } else {
+                    blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                }
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
 				return true;
             }
         }
         return false;
     }
+
 }
